#!/bin/sh
#interfaz Xdialog para arrancar flrec, grabar desde mesa mezclas y
# guardar el output en el ordenata como ogg/mp3 (PARA PROGRAMAS).
#Utiliza flrec/sox para la grabacion (flrec-programas hack), di para el uso del disco,
# bc para calcular el espacio en disco, file para determinar tipo de archivo y
# vorbiscomment / id3v2 para meter comentarios en el archivo de audio (ogg / mp3).
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variables utiles (paths y tal):
#DIRPROGRAMAS=/home/martintxo/pruebas
DIRPROGRAMAS=/home/garraxi/Biltegi/Programas
DIRTEMP=/tmp
#CONFIGPROGRAMAS=/home/martintxo/pruebas/config-programas3.txt
CONFIGPROGRAMAS=/home/garraxi/.programas-radio/config-programas.txt
#DIPATH=/
DIPATH=/home/garraxi/Biltegi/Programas

###################
# Funcion para si se elige meter el nombre a mano:
amano()
{
#GUI para meter a mano el nombre del archivo donde se graba:
GUI=`Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
        --backtitle "En el disco duro donde se guardan los Programas (sdb1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacin." \
	--stdout --left --separator "|" \
	--check "Guardar otro programa que pueda existir con igual nombre" "on" \
	--inputbox "Introduce un nombre descriptivo para el programa que vas a grabar.\n * Ejemplo: Programa_especial_Nochevieja2006.\n * Utiliza un nombre sencillo, con pocas palabras, y sin letras raras ( \"'s\" ), ni espacios.\n * El archivo se guarda en la carpeta ~/Biltegi/Programas/Emision/Nombre_programa.\n    ES MEJOR QUE NO LO MUEVAS DE AH.\n * Selecciona botn \"Guardar...\", para guardar otro programa que pudiera haber con el MISMO nombre.\n    Se guardara en una subcarpeta de /Backup aadiendo fecha/hora de grabacin al nombre.\n * Controla el espacio libre del disco (arriba) y si quedara poco avisa a l*s admins\n      (en la asamblea o en garraxi@sindominio.net).\n         -------------------\n * Tras dar al OK te aparecer la ventana del programa grabador.\n * Haz click en el botn pequeo que hay encima del que tiene un crculo rojo.\n * Despus haz click en el botn del crculo rojo y EMPEZAR A GRABAR.\n         -------------------\n * Cuando acabes de grabar haz click en el botn del cuadrado verde (finaliza la grabacin).\n * Despus cierra el programa con la \"x\" de arriba a la derecha.\n * Aparecer una ventana informativa similar a esta, sigue sus instrucciones.\nGracias :-D!!." \
0 0 "" `
#Para que salga sin hacer nada, si se presiona Cancelar o si se pincha el boton "cerrar programa" del windowmanager:
STATUSRET=$?
if [ $STATUSRET -eq 1 ] || [ $STATUSRET -eq 255 ];then
  exit;
fi
#Quita a $GUI el output de --check que aparece despues de un espacio y puede ser checked o unchecked:
# Con sed: GUI2=`echo "$GUI" | sed 's/[u]\?[n]\?checked//i'`
GUI2=`echo "$GUI" | gawk 'BEGIN{IGNORECASE=1} { gsub (/'[u]?[n]?checked'/, ""); print }' 2> /dev/null`
#Cuando NO se introduce nombre archivo, vuelve a aparecer el programa desde el principio:
if [ "$GUI2" = "" ];then
 Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
	--infobox "OOOPS!!\nParece que se te ha olvidado introducir un nombre de archivo.\nIntentalo de nuevo :-D..." 0 0 5000;
  exec flrec-grabaprograma.sh;
fi
}
###################

#Variable que lee los programas dados de alta desde el archivo de "configuracion":
#Lo de 'grep -v "^#"' para buscar comentarios y dar de output el resto del archivo
LISTA=`grep -v "^#" "$CONFIGPROGRAMAS" | grep -i -A 1 "SeGraba: si" - | grep -i "Nombre:" - | cut -s -d " " -f 2`
PROGRAMAS="`echo "Selecciona_nombre..." && echo "$LISTA" && echo "Meter_nombre_a_mano_(en_otra_ventana)..."`"

#Variable que guarda informacion sobre espacio libre en disco:
# Con df problema: segun baja el tamao disponible, cambia el output de df y cut puede no encontrar el valor
# solucion: utilizar di (pero hace honor a LANG y da decimales separados por comas, y eso no gusta a bc)
DISCO="`export LANG=en; di -f v -n -m -w 0 $DIPATH; export LANG=es_ES`"

#Con la tasa de bits a la que grabamos con flrec/sox (90 kb/s) una hora ocupa aprox 30 Mb.
#Por lo que en sdb1 (17.654Mb) pueden llegar a caber unos 580 programas de 1 hora.
#'bc' para calculo, 'expr' no decimales: http://www.webservertalk.com/archive109-2007-9-2041143.html
HORAS=$(echo "scale=1; $DISCO/30" | bc)

#GUI para seleccionar el nombre del archivo donde se graba:
GUI=`Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
        --backtitle "En el disco duro donde se guardan los Programas (sdb1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacin." \
	--stdout --left --separator "|" \
	--check "Guardar el archivo del programa anterior" "on" \
	--combobox "Selecciona el nombre de tu programa (el asignado en la parrilla).\n * Ejemplo: Saltsa_Berde\n * El archivo se guarda en la carpeta ~/Biltegi/Programas/Emision/Nombre_programa.\n    NO LO MUEVAS DE AH (ni le cambies el nombre).\n    Solo si est en esa carpeta se emitar automticamente.\n * Selecciona botn \"Guardar...\", para guardar el programa de la vez anterior.\n    Se guarda en una subcarpeta de /Backup, aadiendo fecha/hora de grabacin al nombre.\n * Controla el espacio libre del disco (arriba) y si quedara poco avisa a l*s admins\n      (en la asamblea o en garraxi@sindominio.net).\n         -------------------\n * Tras dar al OK te aparecer la ventana del programa grabador.\n * Haz click en el botn pequeo que hay encima del que tiene un crculo rojo.\n * Despus haz click en el botn del crculo rojo y EMPEZAR A GRABAR.\n         -------------------\n * Cuando acabes de grabar haz click en el botn del cuadrado verde (finaliza la grabacin).\n * Despus cierra el programa con la \"x\" de arriba a la derecha.\n * Aparecer una ventana informativa similar a esta, sigue sus instrucciones.\nGracias :-D!!." \
0 0 \
$PROGRAMAS"" `
	
#Para que salga sin hacer nada, si se presiona Cancelar o si se pincha el boton "cerrar programa" del windowmanager:
STATUSRET=$?
if [ $STATUSRET -eq 1 ] || [ $STATUSRET -eq 255 ];then
  exit;
fi

#Quita a $GUI el output de --check que aparece despues de un espacio y puede ser checked o unchecked:
# Con sed: GUI2=`echo "$GUI" | sed 's/[u]\?[n]\?checked//i'`
GUI2=`echo "$GUI" | gawk 'BEGIN{IGNORECASE=1} { gsub (/'[u]?[n]?checked'/, ""); print }' 2> /dev/null`

#Cuando NO se selecciona bien la casilla, vuelve a aparecer el programa:
if [ "$GUI2" = "Selecciona_nombre..." ];then
 Xdialog --wmclass "grabar" --title "Grabar PROGRAMAS" \
	--infobox "OOOPS!!\nParece que te has equivocado al seleccionar un nombre de programa adecuado.\nIntentalo de nuevo :-D..." 0 0 5000;
  exec flrec-grabaprograma.sh;
fi

#Cuando se selecciona "meter nombre a mano" aparece otro cuadro de dialogo similar::
if [ "$GUI2" = "Meter_nombre_a_mano_(en_otra_ventana)..." ];then
   amano
fi

#Cuando SI se selecciona bien la casilla (es igual si se viene desde el "a mano")...
if [ "$GUI2" != "Selecciona_nombre..." ];then

 #Ver si existe algun (1 o varios) archivos de programa anterior en emision en el dir del programa:
 if  [ -d "$DIRPROGRAMAS/Emision/$GUI2" ] ;then
  # para parsear correctamente los espacios en los nombres de archivo:
  #$IFS (Input Field Separators) indica el separador utilizado, y el estandar en bash es un espacio, lo cambiamos
  OLDIFS=$IFS
  IFS=
  for PROGANT in $( find "$DIRPROGRAMAS/Emision/$GUI2" -maxdepth 1 -type f \( -iname '*.ogg' -o -iname '*.mp3' \) -printf "%p$IFS") ; do
  #Hay que devolver el separador standar, si no no funciona lo de checked/unchecked:
  IFS=$OLDIFS
  
   #SOLUCIONAR BUG soma-run que no emite el jingle definido en el palinsesto (quitar cuando bug solucionado). 
   #ver: http://lists.autistici.org/message/20080214.182240.5780d64c.en.html
   #Si archivo encontrado = 000000jingle.[mp3|ogg] => se salta el bucle (ese sera el nombre del jingle, en todos los casos):
   if [ "`basename "$PROGANT" | grep -i '000000jingle'`" ];then 
    continue  #se salta este loop for y comienza otro
   fi
   #FIN SOLUCIONAR BUG JINGLE
  
   if [ "$PROGANT" != "" ] ;then
    #Parsea el output de --check para mover y renombrar o no el archivo anterior:
    for i in $GUI ; do
       case $i in
 	  checked)
	    #Si el archivo de programa anterior es reemision de programa en backup (duplicado) lo borra:
	    DUPLICS=`stat -c %h "$PROGANT"`
	    if [ "$DUPLICS" != "1" ];then
             rm "$PROGANT"
	    else
	    #Si el archivo de programa a mover NO es una reemision lo backupea:
	     #Variables obtener fecha y hora del programa anterior en emision desde fecha de ultimo acceso, y su extension:
	     DATEHOURANT=`stat -c %x "$PROGANT"`
              if basename "$PROGANT" | grep -i '.ogg' > /dev/null ;then
                 EXTANT=ogg
              else
                 EXTANT=mp3
              fi
	     DATEANT=`echo "$DATEHOURANT" | cut --delimiter=" " -f 1 -s`
             HOURANT=`echo "$DATEHOURANT" | cut --delimiter=" " -f 2 -s | cut -c '-8'`
	     
             #Comprueba si hay algun archivo con ese nombre en el dir de backup, y sisi le aade un "+" hasta que deje de haber:
             while [[ -f "$DIRPROGRAMAS/Backup/$GUI2/$GUI2-$DATEANT-$HOURANT.$EXTANT" ]];do 
               HOURANT=${HOURANT}+
             done
	     
	     #Backupea el archivo anterior:	     
	     install -d "$DIRPROGRAMAS/Backup/$GUI2" && mv "$PROGANT" "$DIRPROGRAMAS/Backup/$GUI2/$GUI2-$DATEANT-$HOURANT.$EXTANT"
            fi
           ;;
	 unchecked)
	    rm "$PROGANT"
	   ;;
       esac
    done
   fi
  done
 fi

 #Variable para meter la fecha del programa que vamos a grabar en los comentarios del ogg/mp3:
 DATE=`date +%d/%m/%Y_%H:%M:%S`;

 #Arranca el flrec-programas con las opciones adecuadas, listo para grabar:
 #Graba el programa en dir /tmp para que no exista durante su grabacion y asi un Somad arrancado no pueda
 # comenzar a emitir el programa que se esta grabando en ese momento.
 flrec-programas -q "$DIRTEMP/$GUI2";
    #Cuando no se ha grabado nada, o el archivo creado tiene tamao 0 bytes, sale sin decir nada, si no continua:
    if  [ ! -f "$DIRTEMP/$GUI2" ] || [ ! -s "$DIRTEMP/$GUI2" ] ;then
      exit
    fi 
 FORMAT=`file --mime --brief "$DIRTEMP/$GUI2"`

 if [ "$FORMAT" = "application/ogg" ]; then
   vorbiscomment -a -t "TITLE=Programa \"$GUI2\", grabado el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -t "ARTIST=Realizador@s de \"$GUI2\"" -t "DATE=$DATE" -t "COPYRIGHT=Las personas que hacen el programa \"$GUI2\"" -t "LICENSE=Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-CompartirIgual\": http://creativecommons.org/licenses/by-sa/2.5/es/" -t "ORGANIZATION=Garraxi Irratia" -t "CONTACT=http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI2"
   EXT="ogg"  
 elif [ "$FORMAT" = "audio/mpeg" ]; then
   id3v2 -t "Programa \"$GUI2\", grabado el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -a "Realizador@s de \"$GUI2\"" --TDAT "$DATE" -y `echo "$DATE" | cut --delimiter="_" -f 1 -s | cut --delimiter="/" -f 3 -s` --WCOP "Las personas que hacen el programa \"$GUI2\"" -c "Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-CompartirIgual\"." --TPUB "Garraxi Irratia" --WPUB "http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI2"
   EXT="mp3"
 else
   EXT="formato.desconocido"
 fi
  
 #Al finalizar la grabacion, mueve el archivo grabado a la carpeta adecuada (creandola si no existe) en dir Emision:   
 install -d "$DIRPROGRAMAS/Emision/$GUI2" && mv "$DIRTEMP/$GUI2" "$DIRPROGRAMAS/Emision/$GUI2/$GUI2.$EXT"
 #GUI con la info final:
 Xdialog --wmclass "soma" --title "Grabar PROGRAMAS" --ok-label "FIN" --left  --timeout 20 \
        --msgbox "          BIEEEN :-D!!.\nHas terminado de grabar tu programa y ha quedado guardado en:\n    "$DIRPROGRAMAS/Emision/"$GUI2"/"$GUI2".$EXT"\nRecuerda que para que tu programa se re-emita automticamente\n   tiene que estar \"dado de alta\" en la parrilla de Somad.\n   Si no lo est, comntalo en la asamblea, dselo a alguien de Garraxi,\n   o escribenos a garraxi@sindominio.net.\nGracias :-D!!" 0 0;

 exit $?
	
fi
